Index: src/Filling/Predicates/Ops_FillPredicate_impl.hpp
===================================================================
--- src/Filling/Predicates/Ops_FillPredicate_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/Ops_FillPredicate_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,80 @@
+/*
+ * Ops_FillPredicate_impl.hpp
+ *
+ *  Created on: 17.01.2012
+ *      Author: heber
+ */
+
+#ifndef OPS_FILLPREDICATE_IMPL_HPP_
+#define OPS_FILLPREDICATE_IMPL_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FillPredicateBase.hpp"
+
+/** Logical AND composition of two FillPredicate's.
+ *
+ */
+class And_FillPredicate : public FillPredicateBase
+{
+public:
+	And_FillPredicate(const FillPredicate::impl_ptr &_a, const FillPredicate::impl_ptr &_b) :
+		a(_a), b(_b)
+	{}
+	virtual ~And_FillPredicate()
+	{}
+
+	bool operator()(const Node &n) const {
+		return (*a)(n) && (*b)(n);
+	}
+
+private:
+	FillPredicate::impl_ptr a;
+	FillPredicate::impl_ptr b;
+};
+
+/** Logical OR composition of two FillPredicate's.
+ *
+ */
+class Or_FillPredicate : public FillPredicateBase
+{
+public:
+	Or_FillPredicate(const FillPredicate::impl_ptr &_a, const FillPredicate::impl_ptr &_b) :
+		a(_a), b(_b)
+	{}
+	virtual ~Or_FillPredicate()
+	{}
+
+	bool operator()(const Node &n) const {
+		return (*a)(n) || (*b)(n);
+	}
+
+private:
+	FillPredicate::impl_ptr a;
+	FillPredicate::impl_ptr b;
+};
+
+/** Logical NOT composition of two FillPredicate's.
+ *
+ */
+class Not_FillPredicate : public FillPredicateBase
+{
+public:
+	Not_FillPredicate(const FillPredicate::impl_ptr &_a) :
+		a(_a)
+	{}
+	virtual ~Not_FillPredicate()
+	{}
+
+	bool operator()(const Node &n) const {
+		return !(*a)(n);
+	}
+
+private:
+	FillPredicate::impl_ptr a;
+};
+
+#endif /* OPS_FILLPREDICATE_IMPL_HPP_ */
Index: src/Filling/unittests/ClusterUnitTest.cpp
===================================================================
--- src/Filling/unittests/ClusterUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/ClusterUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,312 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * ClusterUnitTest.cpp
+ *
+ *  Created on: Jan 17, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Atom/CopyAtoms/CopyAtoms_Simple.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Element/periodentafel.hpp"
+#include "Filling/Cluster.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/Shape.hpp"
+#include "World.hpp"
+#include "WorldTime.hpp"
+
+#include "ClusterUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( ClusterTest );
+
+
+void ClusterTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  // this must not compile: private default Cstor
+  // cluster = new Cluster();
+
+  shape  = new Shape(Sphere());
+
+  // create an atom
+  _atom = World::getInstance().createAtom();
+  const element * hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  CPPUNIT_ASSERT(hydrogen != NULL);
+  _atom->setType(hydrogen);
+  _atom->setPosition(Vector(0.,0.,0.));
+  _atomId = _atom->getId();
+
+  cluster = new Cluster(*shape);
+}
+
+
+void ClusterTest::tearDown()
+{
+  delete cluster;
+
+  World::purgeInstance();
+  WorldTime::purgeInstance();
+}
+
+/** Test whether setting and getting works
+ *
+ */
+void ClusterTest::insert_eraseTest()
+{
+  // check for empty cluster
+  CPPUNIT_ASSERT_EQUAL( (size_t)0, cluster->getAtomIds().size() );
+
+  // Shape is sphere at (0,0,0) with radius 1
+
+  {
+    // insert present atom at center of shape
+#ifndef NDEBUG
+    CPPUNIT_ASSERT_NO_THROW( cluster->insert(_atomId) );
+#else
+    cluster->insert(_atomId);
+#endif
+    CPPUNIT_ASSERT_EQUAL( (size_t)1, cluster->getAtomIds().size() );
+#ifndef NDEBUG
+    CPPUNIT_ASSERT_NO_THROW( cluster->erase(_atomId) );
+#else
+    cluster->erase(_atomId);
+#endif
+  }
+
+  {
+    // erase non-existing atom
+    const atomId_t falseId = _atomId+1;
+    CPPUNIT_ASSERT_EQUAL( (atom *)NULL, World::getInstance().getAtom(AtomById(falseId)) );
+#ifndef NDEBUG
+    std::cout << "The following Assertion is intended and does not present a failure of the test." << std::endl;
+    CPPUNIT_ASSERT_THROW( cluster->erase(falseId), Assert::AssertionFailure );
+#else
+    cluster->erase(falseId);
+#endif
+  }
+
+  {
+    // erase non-present atom
+#ifndef NDEBUG
+    std::cout << "The following Assertion is intended and does not present a failure of the test." << std::endl;
+    CPPUNIT_ASSERT_THROW( cluster->erase(_atomId), Assert::AssertionFailure );
+#else
+    cluster->erase(_atomId);
+#endif
+  }
+
+  {
+    // insert present atom within shape
+    _atom->setPosition(Vector(.5,.5,.5));
+#ifndef NDEBUG
+    CPPUNIT_ASSERT_NO_THROW( cluster->insert(_atomId) );
+#else
+    cluster->insert(_atomId);
+#endif
+    CPPUNIT_ASSERT_EQUAL( (size_t)1, cluster->getAtomIds().size() );
+#ifndef NDEBUG
+    CPPUNIT_ASSERT_NO_THROW( cluster->erase(_atomId) );
+#else
+    cluster->erase(_atomId);
+#endif
+    _atom->setPosition(Vector(0.,0.,0.));
+  }
+
+  {
+    // insert present atom outside shape
+    _atom->setPosition(Vector(2.,0.,0.));
+#ifndef NDEBUG
+    std::cout << "The following Assertion is intended and does not present a failure of the test." << std::endl;
+    CPPUNIT_ASSERT_THROW( cluster->insert(_atomId), Assert::AssertionFailure );
+#else
+    cluster->insert(_atomId);
+#endif
+    CPPUNIT_ASSERT_EQUAL( (size_t)0, cluster->getAtomIds().size() );
+    _atom->setPosition(Vector(0.,0.,0.));
+  }
+
+  {
+    // insert present atom on boundary shape
+    _atom->setPosition(Vector(1.,0.,0.));
+#ifndef NDEBUG
+    CPPUNIT_ASSERT_NO_THROW( cluster->insert(_atomId) );
+#else
+    cluster->insert(_atomId);
+#endif
+    CPPUNIT_ASSERT_EQUAL( (size_t)1, cluster->getAtomIds().size() );
+#ifndef NDEBUG
+    CPPUNIT_ASSERT_NO_THROW( cluster->erase(_atomId) );
+#else
+    cluster->erase(_atomId);
+#endif
+    _atom->setPosition(Vector(0.,0.,0.));
+  }
+
+  {
+    // insert non-existing atom
+    const atomId_t falseId = _atomId+1;
+    CPPUNIT_ASSERT_EQUAL( (atom *)NULL, World::getInstance().getAtom(AtomById(falseId)) );
+#ifndef NDEBUG
+    std::cout << "The following Assertion is intended and does not present a failure of the test." << std::endl;
+    CPPUNIT_ASSERT_THROW( cluster->insert(falseId), Assert::AssertionFailure );
+#else
+    cluster->insert(falseId);
+#endif
+    CPPUNIT_ASSERT_EQUAL( (size_t)0, cluster->getAtomIds().size() );
+  }
+}
+
+/** Test whether setting and getting works
+ *
+ */
+void ClusterTest::setter_getterTest()
+{
+  CPPUNIT_ASSERT( *shape == cluster->getShape() );
+
+  CPPUNIT_ASSERT( cluster->atoms == cluster->getAtomIds() );
+}
+
+/** Test whether translate() works
+ *
+ */
+void ClusterTest::translateTest()
+{
+  // insert
+  cluster->insert(_atomId);
+  CPPUNIT_ASSERT_EQUAL( (size_t)1, cluster->getAtomIds().size() );
+
+  // check we are at origin
+  CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0.), cluster->getShape().getCenter() );
+  const atom * _atom = NULL;
+  CPPUNIT_ASSERT_NO_THROW( _atom = cluster->getAtomById(_atomId) );
+  CPPUNIT_ASSERT( _atom != NULL );
+  CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0.), _atom->getPosition() );
+
+  // move
+  cluster->translate( Vector(1.,0.,0.) );
+
+  CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0.), cluster->getShape().getCenter() );
+  CPPUNIT_ASSERT_EQUAL( Vector(1.,0.,0.), cluster->getAtomById(_atomId)->getPosition() );
+}
+
+
+/** Test whether transform() works
+ *
+ */
+void ClusterTest::transformTest()
+{
+  // insert
+  cluster->insert(_atomId);
+  CPPUNIT_ASSERT_EQUAL( (size_t)1, cluster->getAtomIds().size() );
+
+  // check we are at origin
+  CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0.), cluster->getShape().getCenter() );
+  const atom * _atom = NULL;
+  CPPUNIT_ASSERT_NO_THROW( _atom = cluster->getAtomById(_atomId) );
+  CPPUNIT_ASSERT( _atom != NULL );
+  CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0.), _atom->getPosition() );
+
+  // transform
+  RealSpaceMatrix M;
+  M.setIdentity();
+  cluster->transform( M );
+
+  CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0.), cluster->getShape().getCenter() );
+  CPPUNIT_ASSERT_EQUAL( Vector(0.,0.,0.), cluster->getAtomById(_atomId)->getPosition() );
+}
+
+/** Test whether IsInShape() works
+ *
+ */
+void ClusterTest::IsInShapeTest()
+{
+  // at origin we are inside
+  CPPUNIT_ASSERT( shape->isInside(_atom->getPosition() ) );
+  CPPUNIT_ASSERT( cluster->IsInShape(_atomId) );
+
+  // at boundary we are inside
+  _atom->setPosition( Vector(1.,0.,0.) );
+  CPPUNIT_ASSERT( shape->isInside(_atom->getPosition() ) );
+  CPPUNIT_ASSERT( cluster->IsInShape(_atomId) );
+
+  // now we are outside
+  _atom->setPosition( Vector(2.,0.,0.) );
+  CPPUNIT_ASSERT( !shape->isInside(_atom->getPosition() ) );
+  CPPUNIT_ASSERT( !cluster->IsInShape(_atomId) );
+}
+
+/** Test whether clone() works
+ *
+ */
+void ClusterTest::cloneTest()
+{
+  // insert atom ...
+  cluster->insert(_atomId);
+
+  // ... and clone
+  CopyAtoms_Simple copyMethod;
+  ClusterInterface::Cluster_impl clonedCluster = cluster->clone(copyMethod);
+
+  // check for present atom
+  CPPUNIT_ASSERT_EQUAL( (size_t)1, clonedCluster->getAtomIds().size() );
+
+  // check for different ids
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, World::getInstance().getAllAtoms().size() );
+  CPPUNIT_ASSERT( *(cluster->getAtomIds().begin()) != *(clonedCluster->getAtomIds().begin()) );
+  // check for same position
+  atomId_t id = *(clonedCluster->getAtomIds().begin());
+  const atom * const _atom = World::getInstance().getAtom(AtomById(id));
+  CPPUNIT_ASSERT( _atom != NULL );
+  CPPUNIT_ASSERT( (*cluster->getAtomRefs().begin())->getPosition() ==_atom->getPosition() );
+
+  // check that shape is the same
+  CPPUNIT_ASSERT( cluster->getShape() == clonedCluster->getShape() );
+  CPPUNIT_ASSERT( cluster->getShape().getCenter() == clonedCluster->getShape().getCenter() );
+  CPPUNIT_ASSERT( cluster->getShape().getRadius() == clonedCluster->getShape().getRadius() );
+}
+
+/** Test whether getAtomRefs() works
+ *
+ */
+void ClusterTest::getAtomRefsTest()
+{
+  Cluster::AtomVector Atomvec;
+
+  // check with empty cluster
+  CPPUNIT_ASSERT_EQUAL( Atomvec, cluster->getAtomRefs() );
+
+  // insert into both ...
+  Atomvec.push_back(_atom);
+  cluster->insert(_atomId);
+
+  // ...and check again
+  CPPUNIT_ASSERT_EQUAL( Atomvec, cluster->getAtomRefs() );
+}
Index: src/Filling/unittests/ClusterUnitTest.hpp
===================================================================
--- src/Filling/unittests/ClusterUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/ClusterUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,57 @@
+/*
+ * ClusterUnitTest.hpp
+ *
+ *  Created on: Jan 17, 2012
+ *      Author: heber
+ */
+
+#ifndef CLUSTERUNITTEST_HPP_
+#define CLUSTERUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include "types.hpp"
+
+class atom;
+class Cluster;
+class Shape;
+
+/********************************************** Test classes **************************************/
+
+class ClusterTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( ClusterTest) ;
+    CPPUNIT_TEST ( insert_eraseTest );
+    CPPUNIT_TEST ( setter_getterTest );
+    CPPUNIT_TEST ( IsInShapeTest );
+    CPPUNIT_TEST ( getAtomRefsTest );
+    CPPUNIT_TEST ( translateTest );
+    CPPUNIT_TEST ( transformTest );
+    CPPUNIT_TEST ( cloneTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void insert_eraseTest();
+      void setter_getterTest();
+      void IsInShapeTest();
+      void getAtomRefsTest();
+      void translateTest();
+      void transformTest();
+      void cloneTest();
+
+private:
+      Cluster *cluster;
+      Shape *shape;
+      atom * _atom;
+      atomId_t _atomId;
+};
+
+#endif /* CLUSTERUNITTEST_HPP_ */
Index: src/Filling/unittests/FillerUnitTest.cpp
===================================================================
--- src/Filling/unittests/FillerUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/FillerUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,121 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * FillerUnitTest.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Atom/atom.hpp"
+#include "Atom/CopyAtoms/CopyAtoms_Simple.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Element/periodentafel.hpp"
+#include "Filling/Cluster.hpp"
+#include "Filling/Filler.hpp"
+#include "Filling/Inserter/Inserter.hpp"
+#include "Filling/Inserter/SimpleInserter.hpp"
+#include "Filling/Mesh/Mesh.hpp"
+#include "Filling/Predicates/FillPredicate.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "molecule.hpp"
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/Shape.hpp"
+#include "World.hpp"
+#include "WorldTime.hpp"
+
+#include "FillerUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( FillerTest );
+
+
+class MeshStub : public Mesh
+{
+  public:
+  MeshStub() {
+    nodes.reserve(5);
+    for (double i=1; i<6.; ++i)
+      nodes.push_back(Vector(i,0.,0.));
+  }
+  virtual ~MeshStub()
+  {}
+};
+
+void FillerTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  predicate = new FillPredicate(AlwaysFillPredicate());
+  mesh = new MeshStub();
+  inserter = new Inserter(Inserter::impl_ptr(new SimpleInserter()));
+  CPPUNIT_ASSERT_EQUAL( (size_t)5, mesh->getNodes().size() );
+  filler = new Filler(*mesh, *predicate, *inserter);
+  s = new Shape(Sphere( Vector(0.,0.,0.05), 0.1));
+
+  Cluster::atomIdSet atoms;
+
+  // create an atom
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  CPPUNIT_ASSERT(hydrogen != NULL);
+  _atom = World::getInstance().createAtom();
+  _atom->setType(hydrogen);
+  _atom->setPosition( zeroVec );
+  atoms.insert(_atom->getId());
+  _atom = World::getInstance().createAtom();
+  _atom->setType(hydrogen);
+  _atom->setPosition( Vector(0.,0.,0.1) );
+  atoms.insert(_atom->getId());
+
+  CPPUNIT_ASSERT( s->isInside(_atom->getPosition()) );
+  cluster = new ClusterInterface::Cluster_impl(new Cluster(atoms, *s));
+}
+
+
+void FillerTest::tearDown()
+{
+  hydrogen = NULL;
+  delete cluster;
+  delete filler;
+  delete mesh;
+  delete predicate;
+  delete inserter;
+
+  World::purgeInstance();
+  WorldTime::purgeInstance();
+}
+
+/** Test whether operator() works
+ *
+ */
+void FillerTest::operatorTest()
+{
+  CopyAtoms_Simple copyMethod;
+  (*filler)(copyMethod, *cluster);
+
+  // one atom at 5 nodes added
+  CPPUNIT_ASSERT_EQUAL( mesh->getNodes().size()*2, World::getInstance().getAllAtoms().size() );
+}
Index: src/Filling/unittests/FillerUnitTest.hpp
===================================================================
--- src/Filling/unittests/FillerUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/FillerUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,57 @@
+/*
+ * FillerUnitTest.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef FILLERUNITTEST_HPP_
+#define FILLERUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include <boost/shared_ptr.hpp>
+
+#include "types.hpp"
+
+class atom;
+class Cluster;
+class Filler;
+class FillPredicate;
+class Inserter;
+class Mesh;
+class Shape;
+class ClusterInterface;
+typedef boost::shared_ptr<ClusterInterface> Cluster_impl;
+
+/********************************************** Test classes **************************************/
+
+class FillerTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( FillerTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+
+private:
+      FillPredicate *predicate;
+      Mesh *mesh;
+      Inserter *inserter;
+      Filler *filler;
+      atom * _atom;
+      Shape *s;
+      const element * hydrogen;
+      Cluster_impl *cluster;
+};
+
+#endif /* FILLERUNITTEST_HPP_ */
Index: src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp
===================================================================
--- src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,88 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsInsideDomain_FillPredicateUnitTest.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Box.hpp"
+#include "Filling/Predicates/IsInsideDomain_FillPredicate.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "Filling/NodeTypes.hpp"
+
+#include "IsInsideDomain_FillPredicateUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( IsInsideDomain_FillPredicateTest );
+
+
+void IsInsideDomain_FillPredicateTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  M = new RealSpaceMatrix;
+  M->setIdentity();
+  (*M) *= 20.;
+
+  domain = new Box(*M);
+
+  predicate = new FillPredicate(IsInsideDomain_FillPredicate(*domain));
+}
+
+
+void IsInsideDomain_FillPredicateTest::tearDown()
+{
+  delete predicate;
+  delete domain;
+  delete M;
+}
+
+/** Test whether operator() returns as desired
+ *
+ */
+void IsInsideDomain_FillPredicateTest::operatorTest()
+{
+  Node origin(0.,0.,0.);
+  Node center(10.,10.,10.);
+  Node corner(20.,20.,20.);
+  Node outside(30.,30.,30.);
+
+  {
+    // origin is inside
+    CPPUNIT_ASSERT( (*predicate)(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( (*predicate)(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( (*predicate)(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( !(*predicate)(outside) );
+  }
+}
Index: src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp
===================================================================
--- src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,42 @@
+/*
+ * IsInsideDomain_FillPredicateUnitTest.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef ISINSIDEDOMAIN_FILLPREDICATEUNITTEST_HPP_
+#define ISINSIDEDOMAIN_FILLPREDICATEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class Box;
+class RealSpaceMatrix;
+class FillPredicate;
+
+/********************************************** Test classes **************************************/
+
+class IsInsideDomain_FillPredicateTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( IsInsideDomain_FillPredicateTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+
+private:
+      RealSpaceMatrix *M;
+      Box *domain;
+      FillPredicate *predicate;
+};
+
+#endif /* ISINSIDEDOMAIN_FILLPREDICATEUNITTEST_HPP_ */
Index: src/Filling/unittests/IsInsideSurface_FillPredicateUnitTest.cpp
===================================================================
--- src/Filling/unittests/IsInsideSurface_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsInsideSurface_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,129 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsInsideSurface_FillPredicateUnitTest.cpp
+ *
+ *  Created on: Jan 18, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "CodePatterns/Assert.hpp"
+#include "CodePatterns/Log.hpp"
+
+#include "Atom/TesselPoint.hpp"
+#include "LinkedCell/PointCloudAdaptor.hpp"
+#include "Filling/Predicates/IsInsideSurface_FillPredicate.hpp"
+#include "Filling/NodeTypes.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Tesselation/BoundaryLineSet.hpp"
+#include "Tesselation/BoundaryTriangleSet.hpp"
+#include "Tesselation/CandidateForTesselation.hpp"
+#include "Tesselation/tesselation.hpp"
+
+#include "IsInsideSurface_FillPredicateUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+const double IsInsideSurface_FillPredicateTest::SPHERERADIUS=2.;
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( IsInsideSurface_FillPredicateTest );
+
+
+void IsInsideSurface_FillPredicateTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  // create corners
+  class TesselPoint *Walker;
+  Walker = new TesselPoint;
+  Walker->setPosition(Vector(1., 0., -1.));
+  Walker->setName("1");
+  Walker->setNr(1);
+  Corners.push_back(Walker);
+  Walker = new TesselPoint;
+  Walker->setPosition(Vector(-1., 1., -1.));
+  Walker->setName("2");
+  Walker->setNr(2);
+  Corners.push_back(Walker);
+  Walker = new TesselPoint;
+  Walker->setPosition(Vector(-1., -1., -1.));
+  Walker->setName("3");
+  Walker->setNr(3);
+  Corners.push_back(Walker);
+  Walker = new TesselPoint;
+  Walker->setPosition(Vector(-1., 0., 1.));
+  Walker->setName("4");
+  Walker->setNr(4);
+  Corners.push_back(Walker);
+
+  // create linkedcell
+  PointCloudAdaptor<TesselPointSTLList> cloud(&Corners, "TesselPointSTLList");
+  LinkedList = new LinkedCell_deprecated(cloud, 2.*SPHERERADIUS);
+
+  // create tesselation
+  TesselStruct = new Tesselation;
+  (*TesselStruct)(cloud, SPHERERADIUS);
+
+  // create predicate
+  predicate = new FillPredicate(IsInsideSurface_FillPredicate(*TesselStruct, *LinkedList));
+}
+
+
+void IsInsideSurface_FillPredicateTest::tearDown()
+{
+  delete predicate;
+
+  delete(LinkedList);
+  delete(TesselStruct);
+  for (TesselPointSTLList::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++)
+    delete(*Runner);
+  Corners.clear();
+  logger::purgeInstance();
+  errorLogger::purgeInstance();
+
+}
+
+/** Test whether operator() returns as desired
+ *
+ */
+void IsInsideSurface_FillPredicateTest::operatorTest()
+{
+  Node center(0.,0.,0.);
+  Node corner(1.,0.,-1.);
+  Node outside(2.,0.,0.);
+
+  {
+    // center is inside
+    CPPUNIT_ASSERT( (*predicate)(center) );
+  }
+
+  {
+    // corner is inside
+    CPPUNIT_ASSERT( (*predicate)(corner) );
+  }
+
+  {
+    // outside is outside
+    CPPUNIT_ASSERT( !(*predicate)(outside) );
+  }
+}
Index: src/Filling/unittests/IsInsideSurface_FillPredicateUnitTest.hpp
===================================================================
--- src/Filling/unittests/IsInsideSurface_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsInsideSurface_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,47 @@
+/*
+ * IsInsideSurface_FillPredicateUnitTest.hpp
+ *
+ *  Created on: Jan 18, 2012
+ *      Author: heber
+ */
+
+#ifndef ISINSIDESURFACE_FILLPREDICATEUNITTEST_HPP_
+#define ISINSIDESURFACE_FILLPREDICATEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include "LinkedCell/linkedcell.hpp"
+
+class FillPredicate;
+class LinkedCell_deprecated;
+class Tesselation;
+
+/********************************************** Test classes **************************************/
+
+class IsInsideSurface_FillPredicateTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( IsInsideSurface_FillPredicateTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+
+private:
+      static const double SPHERERADIUS;
+
+      TesselPointSTLList Corners;
+      Tesselation *TesselStruct;
+      LinkedCell_deprecated *LinkedList;
+      FillPredicate *predicate;
+};
+
+#endif /* ISINSIDESURFACE_FILLPREDICATEUNITTEST_HPP_ */
Index: src/Filling/unittests/IsValidInDomain_FillPredicateUnitTest.cpp
===================================================================
--- src/Filling/unittests/IsValidInDomain_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsValidInDomain_FillPredicateUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,126 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsValidInDomain_FillPredicateUnitTest.cpp
+ *
+ *  Created on: Jan 18, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Box.hpp"
+#include "Filling/Predicates/IsValidInDomain_FillPredicate.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "Filling/NodeTypes.hpp"
+
+#include "IsValidInDomain_FillPredicateUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( IsValidInDomain_FillPredicateTest );
+
+
+void IsValidInDomain_FillPredicateTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  M = new RealSpaceMatrix;
+  M->setIdentity();
+  (*M) *= 20.;
+
+  domain = new Box(*M);
+
+  predicate = new FillPredicate(IsValidInDomain_FillPredicate(*domain));
+}
+
+
+void IsValidInDomain_FillPredicateTest::tearDown()
+{
+  delete predicate;
+  delete domain;
+  delete M;
+}
+
+/** Test whether operator() returns as desired
+ *
+ */
+void IsValidInDomain_FillPredicateTest::operatorTest()
+{
+  Node origin(0.,0.,0.);
+  Node center(10.,10.,10.);
+  Node corner(20.,20.,20.);
+  Node outside(30.,30.,30.);
+
+  for (size_t i=0;i<NDIM;++i)
+    domain->setCondition(i, BoundaryConditions::Wrap);
+
+  // boundary conditions: Wrap
+  {
+    // origin is inside
+    CPPUNIT_ASSERT( (*predicate)(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( (*predicate)(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( (*predicate)(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( (*predicate)(outside) );
+  }
+
+  // boundary conditions: Bounce
+  {
+    domain->setCondition(0, BoundaryConditions::Bounce);
+    // origin is inside
+    CPPUNIT_ASSERT( (*predicate)(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( (*predicate)(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( (*predicate)(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( (*predicate)(outside) );
+    domain->setCondition(0, BoundaryConditions::Wrap);
+  }
+
+  // boundary conditions: Ignore
+  {
+    domain->setCondition(0, BoundaryConditions::Ignore);
+    // origin is inside
+    CPPUNIT_ASSERT( (*predicate)(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( (*predicate)(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( (*predicate)(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( !(*predicate)(outside) );
+    domain->setCondition(0, BoundaryConditions::Wrap);
+  }
+}
Index: src/Filling/unittests/IsValidInDomain_FillPredicateUnitTest.hpp
===================================================================
--- src/Filling/unittests/IsValidInDomain_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/unittests/IsValidInDomain_FillPredicateUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,42 @@
+/*
+ * IsValidInDomain_FillPredicateUnitTest.hpp
+ *
+ *  Created on: Jan 18, 2012
+ *      Author: heber
+ */
+
+#ifndef ISVALIDINDOMAIN_FILLPREDICATEUNITTEST_HPP_
+#define ISVALIDINDOMAIN_FILLPREDICATEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class Box;
+class RealSpaceMatrix;
+class FillPredicate;
+
+/********************************************** Test classes **************************************/
+
+class IsValidInDomain_FillPredicateTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( IsValidInDomain_FillPredicateTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+
+private:
+      RealSpaceMatrix *M;
+      Box *domain;
+      FillPredicate *predicate;
+};
+
+#endif /* ISVALIDINDOMAIN_FILLPREDICATEUNITTEST_HPP_ */
